import pygame
from pygame.locals import *
from bugs import *
import sys
from Numeric import *
from random import *
from math import *
import pygame.mixer

pygame.init()

global winner 
Font=pygame.font.Font(None, 24)
BigFont=pygame.font.Font(None,72)
POLLCLOCK = USEREVENT + 1
clock = pygame.time.Clock ()
pygame.time.set_timer ( POLLCLOCK, 1000 )
screen = pygame.display.set_mode([1016, 660])
mousemap=zeros((1016,660))
pygame.display.update()
clock.tick ( 20 )
winner =0
dayclock = Daytime(11,20,10,1)
backimage = pygame.image.load("graphics/sidebar.jpg")
backimage.convert()
buttonpressed=0
attack_slider=0
defense_slider=0
move_slider=0
bugs=[]
butdelay=1

pygame.mixer.init()
global soundb,soundc,soundd,sounde,soundf,soundg

soundb= pygame.mixer.Sound("sounds/yum.wav")
soundc= pygame.mixer.Sound("sounds/click.wav")
soundd= pygame.mixer.Sound("sounds/eeeep.wav")
sounde= pygame.mixer.Sound("sounds/ouch.wav")
soundf= pygame.mixer.Sound("sounds/rrrr.wav")
soundg= pygame.mixer.Sound("sounds/slap.wav")
pygame.display.set_caption('Bugs')
def randomdiesound():
   global soundd,sounde,soundf,soundg
   x = randint(1,4)
   if x == 1:
      soundd.play()
   if x ==2:
      sounde.play()
   if x == 3:
      soundf.play()
   if x ==4:
      soundg.play()

def createbutton(x,y,x2,y2,value):
   for loop in range (x,x+x2):
      mousemap[loop][y:y+y2]=value

def stamp(image,x,y):
   image = pygame.image.load(image)
   imagerect = image.get_rect()
   imagerect=imagerect.move(x,y)
   screen.blit(image,imagerect)

def writetext(text,location,color):
   stamp = Font.render (text, True, color)
   screen.blit(stamp,stamp.get_rect().move(location))

def bigwritetext(text,location,color):
   stamp = BigFont.render (text, True, color)
   screen.blit(stamp,stamp.get_rect().move(location))

def findpart(b):

   fleex = -1
   fleey = -1  
   fleedist = 10000
   for c in bugs:
      dist = abs(c.bugx-b.bugx)+abs(c.bugy-b.bugy)
      if c.team != b.team and dist < fleedist:
         fleedist = dist
         fleex=c.bugx
         fleey=c.bugy 
   b.style = 1
   if b.bugx > 655:
      fleex = 661
   if b.bugx < 5:
      fleex = -1
   if b.bugy > 655:
      fleey = 661
   if b.bugy < 5:
      fleey = -1
   if fleedist < 60:
      b.energy=b.energy-15
      if b.bugx >= fleex:
         b.bugx=b.bugx-10
      if b.bugx < fleex:
         b.bugx = b.bugx+10
      if b.bugy >= fleey:
         b.bugy=b.bugy-10
      if b.bugy < fleey:
         b.bugy = b.bugy+10
   b.panicked=1

   distobj = zeros((len(objects),2))
   for c in range (0,len(objects)):
      distobj[c][0]=abs(objects[c].objectx-b.bugx)+abs(objects[c].objecty-b.bugy) 
      distobj[c][1]=objects[c].object_type          
   toparts = 10000
   findparts = -1
   for loop in range (0,len(distobj-1)):
      if distobj[loop][1]<6 and distobj[loop][0]<toparts:
         toparts = distobj[loop][0] 
         findparts = loop    
   if randint(1,100)>(b.attack**2+b.defense**2)/b.move and b.energy>0:
      if b.bugx > objects[findparts].objectx:
         b.bugx=b.bugx-1
      if b.bugx < objects[findparts].objectx:
         b.bugx = b.bugx+1
      if b.bugy > objects[findparts].objecty:
         b.bugy= b.bugy-1
      if b.bugy < objects[findparts].objecty:
         b.bugy = b.bugy+1 
      if randint(1,100)<b.move**2:
         b.energy=b.energy-1 
   if b.bugx == objects[findparts].objectx and b.bugy == objects[findparts].objecty:
      foundpart=0
      b.parthunting=1
      if objects[findparts].object_type==1:
         if objects[findparts].object_rating>b.attack:
            b.attack=objects[findparts].object_rating
            del objects[findparts]
            foundpart = 1
      if objects[findparts].object_type==2 and foundpart==0:
         if objects[findparts].object_rating>b.defense:
            b.defense=objects[findparts].object_rating
            del objects[findparts]
            foundpart = 1
      if objects[findparts].object_type==3 and foundpart==0:
         if objects[findparts].object_rating>b.move:
            b.move=objects[findparts].object_rating
            del objects[findparts]
            foundpart = 1
      if objects[findparts].object_type==4 and foundpart==0:
         if objects[findparts].object_rating!=b.power:
            b.power=objects[findparts].object_rating
            del objects[findparts]
            foundpart = 1
      if objects[findparts].object_type==5 and foundpart==0:
         if objects[findparts].object_rating!=b.style:
            b.style=objects[findparts].object_rating
            del objects[findparts]
            foundpart = 1
      if foundpart == 0:
         del objects[findparts]
      else:
         b.panicked=0
  


def turn_update():
   global buttonpressed
   for b in bugs:
      if b.team==1:
         if buttonpressed == 2:
            b.style=1
         if buttonpressed == 3:
            b.style=2
         if buttonpressed ==4:
            b.style = 3
   for b in bugs:
      if b.team == 1:
         if b.command > 0:
            dist = abs(b.bugx-b.commandx)+abs(b.bugy-b.commandy)
            if dist > 5 and b.command2==0:
               if randint(1,100)>(b.attack**2+b.defense**2)/b.move and b.energy>0:
                  if b.bugx > b.commandx:
                     b.bugx=b.bugx-1
                  if b.bugx < b.commandx:
                     b.bugx = b.bugx+1
                  if b.bugy > b.commandy:
                     b.bugy= b.bugy-1
                  if b.bugy < b.commandy:
                     b.bugy = b.bugy+1 
                  if randint(1,100)<b.move**2:
                     b.energy=b.energy-1 
            else:
               b.command2= 1
               b.commandx=0
               b.commandy=0
               distobj = zeros((len(objects),3))
               for c in range (0,len(objects)):
                  distobj[c][0]=abs(objects[c].objectx-b.bugx)+abs(objects[c].objecty-b.bugy) 
                  distobj[c][1]=objects[c].object_type  
                  distobj[c][2]=objects[c].object_rating        
               toparts = 10000
               findparts = -1
               for loop in range (0,len(distobj-1)):
                  if distobj[loop][1]==b.command and distobj[loop][0]<toparts:
                     if b.command !=4: 
                        toparts = distobj[loop][0] 
                        findparts = loop
                     else: 
                        if distobj[loop][2]==b.command3: 
                           toparts = distobj[loop][0] 
                           findparts = loop

               if randint(1,100)>(b.attack**2+b.defense**2)/b.move and b.energy>0:
                  if b.bugx > objects[findparts].objectx:
                     b.bugx=b.bugx-1
                  if b.bugx < objects[findparts].objectx:
                     b.bugx = b.bugx+1
                  if b.bugy > objects[findparts].objecty:
                     b.bugy= b.bugy-1
                  if b.bugy < objects[findparts].objecty:
                     b.bugy = b.bugy+1 
                  if randint(1,100)<b.move**2:
                     b.energy=b.energy-1 
               if b.bugx == objects[findparts].objectx and b.bugy == objects[findparts].objecty:
                  if b.command == 1:
                     if objects[findparts].object_rating > b.attack:
                        b.attack=objects[findparts].object_rating
                  if b.command == 2:
                     if objects[findparts].object_rating > b.defense:
                        b.defense=objects[findparts].object_rating
                  if b.command == 3:
                     if objects[findparts].object_rating > b.move:
                        b.move=objects[findparts].object_rating
                  if b.command ==4:
                     b.power=b.command3
                  if b.command == 6:
                     multiplier=1
                     if b.power == 1:
                        multiplier=2
                     if b.power == 2:
                        multiplier=4
                     if b.power == 3:
                        multplier=1
                     b.energy = b.energy+(objects[findparts].object_rating**2)*multiplier
                  b.command2=0
                  b.command3=0
                  if b.command != 5:
                     del objects[findparts]
                  b.command=0   
            if b.style==1:
               if b.energy<100:
                  findfood(b)
               if b.health<12:
                  findpart(b)
               else:
                  flee(b)
            if b.style==2:
               if b.energy<50:
                  findfood(b)
               if b.health<12:
                  findpart(b)
               else:
                  hunt(b)
            if b.style==3:
               if b.energy<10:
                  findfood(b)
               if b.health<12:
                  findpart(b)
               else:
                  hunt(b)                    


   for b in bugs:
      if b.power == 3:
         if randint(1,200) < dayclock.time():
            b.energy=b.energy+1
            if randint(1,20)==1:
               b.health=b.health+1
   checkforfights()
   for b in bugs:
      if b.style==1 and b.team != 1:
         if b.energy<100:
            findfood(b)
         if b.health<12:
            findpart(b)
         else:
            flee(b)
      if b.style==2 and b.team!=1:
         if b.energy<50:
            findfood(b)
         if b.health<12:
            findpart(b)
         else:
            hunt(b)
      if b.style==3 and b.team!=1:
         if b.energy<10:
            findfood(b)
         if b.health<12:
            findpart(b)
         else:
            hunt(b)  
   for b in bugs:
      if b.bugx<1:
         b.bugx=1
      if b.bugx>660:
         b.bugx=660
      if b.bugy<1:
         b.bugy=1
      if b.bugy>660:
         b.bugy=660  
      if b.energy>200:
         b.energy=b.energy-150 
         team=b.team
         newx=b.bugx+randint(1,31)-16
         newy=b.bugy+randint(1,31)-16
         attack=b.attack
         defense=b.defense
         power=b.power
         style=b.style
         bugs.append(Bug(2,team,newx,newy,attack,defense,power,style))
      if b.health > 40:
         b.health = 40
      if b.style == 2: 
            b.pred_burst=b.pred_burst +1
      if randint(1,3)==1:
            b.pred_burst=b.pred_burst + 1
      if b.health > 20 and b.parthunting==1:
         b.parthunting=0
      if b.energy < 1:
         b.health = -1

def redrawboard():
   global attack_slider,defense_slider,move_slider,clickx,winner
   howlight=dayclock.time()
   brt=min((howlight*200/100),255)
   pygame.draw.rect(screen,(brt+20,brt+20,brt),(0,0,660,660),0)
   
   screen.blit(backimage,backimage.get_rect().move(660,0))
   pygame.draw.rect(screen,(0,0,0),(660,0,5,660))
   dayclock.click()
   teamscore = zeros((11))
   for b in bugs:
      distbugs=distarray(b)
      b.update(objects,distbugs)
      screen.blit(b.image, b.rect)
      teamscore[b.team]=teamscore[b.team]+1
      teamscore[0]=teamscore[0]+1
   for loop in range (1,11):
      if .66*teamscore[0] < teamscore[loop]:
         winner = loop
         pass     
   for o in objects:
      x,y=o.update()
      if o.object_type == 1:
         pygame.draw.rect(screen,(255,0,0),(x,y,2,2),0)
      if o.object_type == 2:
         pygame.draw.rect(screen,(0,0,255),(x,y,2,2),0)      
      if o.object_type == 3:
         pygame.draw.rect(screen,(255,255,0),(x,y,2,2),0)      
      if o.object_type == 4:
         pygame.draw.rect(screen,(0,255,0),(x,y,2,2),0)      
      if o.object_type == 5:
         pygame.draw.rect(screen,(255,0,255),(x,y,2,2),0)
      if o.object_type == 6:
         pygame.draw.rect(screen,(0,255,255),(x,y,2,2),0)


   writetext("Time = "+str(time),(680,20),(0,0,0))
   percentage = 100*(1.0*teamscore[1])/(1.0*teamscore[0])
   writetext("Percentage Player Control "+str(percentage)[0:2],(680,40),(0,0,0))
   
   writetext("Sunlight " + str(dayclock.time()),(680,60),(0,0,0))
   writetext("Seasons "+ dayclock.season(),(680,80),(0,0,0))
   stamp("graphics/button1.bmp",680,105)
   stamp("graphics/button1.bmp",680,140)
   stamp("graphics/button1.bmp",760,140)
   stamp("graphics/button1.bmp",840,140)
   stamp("graphics/button1.bmp",680,175)
   stamp("graphics/button1.bmp",760,175)
   stamp("graphics/button1.bmp",680,210)
   stamp("graphics/button1.bmp",680,245)
   stamp("graphics/button1.bmp",760,245)
   stamp("graphics/button1.bmp",840,245)
   stamp("graphics/button1.bmp",680,280)
   stamp("graphics/button1.bmp",760,280)
   stamp("graphics/button1.bmp",840,280)
   stamp("graphics/button1.bmp",680,310)
   createbutton(680,110,75,25,1)
   createbutton(680,145,75,25,2)
   createbutton(760,145,75,25,3)
   createbutton(840,145,75,25,4)
   createbutton(680,180,75,25,5)
   createbutton(760,180,75,25,6)
   createbutton(680,215,75,25,7)
   createbutton(680,250,75,25,8)
   createbutton(760,250,75,25,9)
   createbutton(840,250,75,25,10)
   createbutton(680,285,75,25,11)
   createbutton(760,285,75,25,12)
   createbutton(840,285,75,25,13)
   createbutton(680,315,75,25,14)
   createbutton(680,490,75,25,15)
   if buttonpressed == 2:
      stamp("graphics/button2.bmp",680,140)
   if buttonpressed == 3:
      stamp("graphics/button2.bmp",760,140)   
   if buttonpressed == 4:
      stamp("graphics/button2.bmp",840,140)
   if buttonpressed == 5:
      stamp("graphics/button2.bmp",680,175)
   if buttonpressed == 6: 
      stamp("graphics/button2.bmp",760,175)
   if buttonpressed == 7: 
      stamp("graphics/button2.bmp",680,245)
   if buttonpressed == 8: 
      stamp("graphics/button2.bmp",680,245)
   if buttonpressed == 9: 
      stamp("graphics/button2.bmp",760,245)
   if buttonpressed == 10:
      stamp("graphics/button2.bmp",840,245)
   if buttonpressed == 11: 
      stamp("graphics/button2.bmp",680,280)
   if buttonpressed == 12: 
      stamp("graphics/button2.bmp",760,280)
   if buttonpressed == 13: 
      stamp("graphics/button2.bmp",840,280)
   if buttonpressed == 14: 
      stamp("graphics/button2.bmp",680,310)





   writetext("Style",(695,108),(0,0,0))
   writetext("Flee",(700,143),(0,0,0))
   writetext("Hunt",(785,143),(0,0,0))
   writetext("Eat",(865,143),(0,0,0))
   writetext("Meet",(695,178),(0,0,0))
   writetext("Clear",(780,178),(0,0,0))
   writetext("Power",(695,213),(0,0,0))
   writetext("Hunt",(700,248),(0,0,0))
   writetext("Base",(780,248),(0,0,0))
   writetext("Plant",(860,248),(0,0,0))
   writetext("Attack",(695,283),(0,0,0))
   writetext("Defense",(770,283),(0,0,0))
   writetext("Move",(860,283),(0,0,0))
   writetext("Food",(700,313),(0,0,0))


   pygame.draw.rect(screen,(0,0,0),(660,0,5,660))
   pygame.display.update()

def findfood(self): 
   distobj = zeros((len(objects),2))
   for c in range (0,len(objects)):
      distobj[c][0]=abs(objects[c].objectx-self.bugx)+abs(objects[c].objecty-self.bugy) 
      distobj[c][1]=objects[c].object_type          
   tofood = 10000
   findfood = -1
   for loop in range (0,len(distobj-1)):
      if distobj[loop][1]==6 and distobj[loop][0]<tofood:
         tofood = distobj[loop][0] 
         findfood = loop
 
   if randint(1,100)>(self.attack**2+self.defense**2)/self.move and self.energy>0:
      if self.bugx > objects[findfood].objectx:
         self.bugx=self.bugx-1
      if self.bugx < objects[findfood].objectx:
         self.bugx = self.bugx+1
      if self.bugy > objects[findfood].objecty:
         self.bugy=self.bugy-1
      if self.bugy < objects[findfood].objecty:
         self.bugy = self.bugy+1 
      if randint(1,100)<self.move**2:
         self.energy=self.energy-1 
   if self.bugx == objects[findfood].objectx and self.bugy == objects[findfood].objecty:
      multiplier=1
      if self.power == 1:
         multiplier=2
      if self.power == 2:
         multiplier=4
      if self.power == 3:
         multplier=1
      self.energy = self.energy+(objects[findfood].object_rating**2)*multiplier
      del objects[findfood] 
      soundb.play()


def distarray(b):
   distbugs = zeros((len(bugs),2))

   for c in range (0,len(bugs)):
      distbugs[c][0]= abs(bugs[c].bugx-b.bugx)+abs(bugs[c].bugy-b.bugy)
      if distbugs[c][0]==0:
         distbugs[c][0]=2000 
      distbugs[c][1]=bugs[c].team  
 
   return distbugs    

def drawbutton(button):
   global mousemap,screen
   for x in range (0,1016):
      for y in range (0,660):
         if mousemap[x][y]==button:
            pygame.draw.circle(screen, (255,255,255), (x,y), 2, 1)
   pygame.display.flip() 

def calcarc(unit,targetx,targety):
   unitx,unity = unit.position
   if unitx >= targetx and unity >= targety:
      angle = 360-degrees(atan(float(unitx-targetx)/float(unity-targety+.01)))
   if unitx >= targetx and unity < targety:
      angle = 180-degrees(atan(float(unitx-targetx)/float(unity-targety+.01)))
   if unitx < targetx and unity >= targety:
      angle = -degrees(atan(float(unitx-targetx)/float(unity-targety+.01)))
   if unitx < targetx and unity < targety:
      angle = 180-degrees(atan(float(unitx-targetx)/float(unity-targety+.01)))
   return angle

def flee(b):
   fleex = -1
   fleey = -1  
   fleedist = 10000
   for c in bugs:
      dist = abs(c.bugx-b.bugx)+abs(c.bugy-b.bugy)
      if c.team != b.team and dist < fleedist:
         fleedist = dist
         fleex=c.bugx
         fleey=c.bugy
   if b.bugx > 655:
      fleex = 661
   if b.bugx < 5:
      fleex = -1
   if b.bugy > 655:
      fleey = 661
   if b.bugy < 5:
      fleey = -1
   if randint(1,100)>(b.attack**2+b.defense**2)/b.move and b.energy>0:
      if b.bugx > c.bugx:
         b.bugx=b.bugx-1
      if b.bugx < c.bugx:
         b.bugx = b.bugx+1
      if b.bugy > c.bugx:
         b.bugy=b.bugy-1
      if b.bugy < c.bugx:
         b.bugy = b.bugy+1 
      if randint(1,100)<b.move**2:
         b.energy=b.energy-1  

def hunt(b):
   huntx = -1
   hunty = -1  
   huntdist = 10000
   for c in bugs:
      dist = abs(c.bugx-b.bugx)+abs(c.bugy-b.bugy)
      if c.team != b.team and dist < huntdist:
         huntx=c.bugx
         hunty=c.bugy
         huntdist = dist
   if randint(1,100)>(b.attack**2+b.defense**2)/b.move and b.energy>0:
      if b.bugx < huntx:
         b.bugx=b.bugx-1
      if b.bugx > huntx:
         b.bugx = b.bugx+1
      if b.bugy < hunty:
         b.bugy=b.bugy-1
      if b.bugy > hunty:
         b.bugy = b.bugy+1 
      if randint(1,100)<b.move**2:
         b.energy=b.energy-1 
   if b.pred_burst>0 and dist < 60 and b.style==2:
      b.pred_burst = b.pred_burst -1
      b.energy=b.energy-1
      if b.bugx < c.bugx:
         b.bugx=b.bugx-1
      if b.bugx > c.bugx:
         b.bugx = b.bugx+1
      if b.bugy < c.bugx:
         b.bugy=b.bugy-1
      if b.bugy > c.bugx:
         b.bugy = b.bugy+1 
 

  
      
def checkforfights():
   for b in bugs:
      for c in bugs:
         if abs(c.bugx-b.bugx)+abs(c.bugy-b.bugy) < 15 and b.team != c.team and b.health>0:
            c.health=c.health-max(0, b.attack*2 - c.defense)
            b.health=b.health+12+int(random()*b.attack)
            b.energy=b.energy-randint(1,b.attack)
   for loop in range(len(bugs)-1,-1,-1):
      if bugs[loop].health<1:
         bx=bugs[loop].bugx
         by=bugs[loop].bugy
         objects.append(Object((6),randint(1,5),bx+randint(1,11)-5,by+randint(1,11)-5))
         objects.append(Object((6),randint(1,5),bx+randint(1,21)-11,by+randint(1,21)-11))
         objects.append(Object((1),bugs[loop].attack,randint(1,660),randint(1,660)))
         objects.append(Object((2),bugs[loop].defense,randint(1,660),randint(1,660)))
         objects.append(Object((3),bugs[loop].move,randint(1,660),randint(1,660)))
         objects.append(Object((4),bugs[loop].power,randint(1,660),randint(1,660)))
         objects.append(Object((5),bugs[loop].style,randint(1,660),randint(1,660)))
   for loop in range(len(bugs)-1,-1,-1):
      if bugs[loop].health<1:
         #print "aaahhhhh",len(bugs)
         del bugs[loop]
         randomdiesound()
      
def addunits(team,number):
   loop=0
   while loop < number:
      newx = randint(15,645)
      newy = randint(15,645)
      ok = 0 
      for b in bugs:
         distance = abs(newx-b.bugx)+abs(newy-b.bugy)
         if distance < 15:
            ok =1 
      if ok == 0:  
         loop = loop + 1   
         bugs.append(Bug(team,newx,newy,randint(1,7),randint(1,3),randint(1,7),\
            randint(1,3),randint(1,3))) 


def gameover(won):
   global buttonpressed,winner
   winner=won
   stamp("graphics/YouWonImage.jpg",0,0)   
   bigwritetext("Player "+str(winner)+" Has Won",(100,80),(0,0,0))
   pygame.draw.rect(screen, (100,145,245),(100,200,150,45),0) 
   pygame.draw.rect(screen, (255,45,45),(100,200,150,45),5)
   pygame.draw.rect(screen, (100,145,245),(300,200,150,45),0) 
   pygame.draw.rect(screen, (255,45,45),(300,200,150,45),5)
   writetext("NewGame",(130,210),(0,0,0))
   writetext("Good Bye",(340,210),(0,0,0))
   createbutton(100,200,150,45,31)
   createbutton(300,200,150,45,32)
   pygame.display.update()
   wait = 1
   while wait:
      for event in pygame.event.get():
         pygame.time.wait(1)
         if event.type == QUIT:
             sys.exit()
         if event.type == KEYDOWN:
            keypress =  pygame.key.name(event.key)
         if event.type == MOUSEBUTTONDOWN:
            clickx,clicky = pygame.mouse.get_pos()
            buttonpressed = mousemap[clickx][clicky]
         if buttonpressed == 32:
            sys.exit()
         if buttonpressed == 31:
            while len(bugs)>0:
               del bugs[0]
            while len(objects)>0:
               del objects[0]
            createbutton(100,200,150,45,0)
            createbutton(300,200,150,45,0)
            newgame()
            winner = 0
            wait = 0 #the wait is over

def newgame():
   global buttonpressed
   checks=('graphics/check1.jpg',"graphics/check2.jpg",'graphics/check3.jpg',\
      "graphics/check4.jpg",'graphics/check5.jpg',"graphics/check6.jpg")

   startinggrid = zeros((14))
   checkgrid = zeros((14))
   startinggrid[1]=2
   for loop in range (2,11):
      startinggrid[loop]=1
   startinggrid[11]=9
   startinggrid[12]=3
   stamp("graphics/settings.jpg",0,0)           
   for loop in range (1,11):  
      writetext("Player "+str(loop),(30,45*loop),(0,0,0))
   writetext("Objects ",(30,45*11),(0,0,0))
   writetext("Food ",(30,45*12),(0,0,0))
   for loop in range (1,20):
      writetext(str(loop*5),(80+40*loop,20),(0,0,0))
   for loop in range(1,13):
      for loop2 in range(1,20):
         pygame.draw.rect(screen, (255,255,255),(75+40*loop2,-1+45*loop,26,26),0) 
         pygame.draw.rect(screen, (0,0,0),(75+40*loop2,-1+45*loop,26,26),1) 
         createbutton(75+40*loop2,-1+45*loop,26,26,50+loop*20+loop2)
   pygame.draw.rect(screen, (255,255,255),(30,570,170,70),0) 
   pygame.draw.rect(screen, (150,150,0),(30,570,170,70),5) 
   bigwritetext("PLAY!",(35,575),(0,0,0))
   createbutton(30,570,170,70,50)    
   for loop in range(1,13):
      checkgrid[loop] = randint(0,5)
      checkimage=checks[checkgrid[loop]]
      stamp(checkimage,78+40*startinggrid[loop],2+45*loop)
   pygame.display.update()
   newwait = 1
   while newwait:
      for event in pygame.event.get():
         pygame.time.wait(1)
         if event.type == QUIT:
             sys.exit()
         if event.type == KEYDOWN:
            keypress =  pygame.key.name(event.key)
         if event.type == MOUSEBUTTONDOWN:
            clickx,clicky = pygame.mouse.get_pos()
            soundc.play()
            buttonpressed = mousemap[clickx][clicky]
            if buttonpressed>70 and buttonpressed < 310:
               for loop in range(1,13):
                  for loop2 in range(1,20):
                    pygame.draw.rect(screen, (255,255,255),(75+40*loop2,-1+45*loop,26,26),0) 
                    pygame.draw.rect(screen, (0,0,0),(75+40*loop2,-1+45*loop,26,26),1)
               row = (buttonpressed - 50)/20
               column = buttonpressed - 50 - (row * 20)
               startinggrid[row]=column
               checkgrid[row]=randint(0,5)
               for loop in range(1,13):
                  checkimage=checks[checkgrid[loop]]
                  stamp(checkimage,78+40*startinggrid[loop],2+45*loop)
            if buttonpressed==50:
               for loop in range (1,11):
                  addunits(loop,startinggrid[loop]*5)
               addobjects(startinggrid[11]*5)
               addfood(startinggrid[12]*5)
               newwait=0
               print startinggrid[11],startinggrid[12]
      pygame.display.update()         


def addfood(number):
   loop = 0 
   while loop < number:
      newx = randint(5,655)
      newy = randint(5,655)
      ok = 0 
      for b in bugs:
         distance = abs(newx-b.bugx)+abs(newy-b.bugy)
         if distance < 5:
            ok =1 
      for o in objects:
         distance = abs(newx-o.objectx)+abs(newy-o.objecty)
         if distance < 5:
            ok =1
      
      if ok == 0:  
         loop = loop + 1    
         objects.append(Object(6,randint(1,15),newx,newy))

def addobjects(number):
   loop = 0 
   while loop < number:
      newx = randint(5,655)
      newy = randint(5,655)
      ok = 0 
      for b in bugs:
         distance = abs(newx-b.bugx)+abs(newy-b.bugy)
         if distance < 5:
            ok =1 
      for o in objects:
         distance = abs(newx-o.objectx)+abs(newy-o.objecty)
         if distance < 5:
            ok =1
      
      if ok == 0:  
         loop = loop + 1    
         objects.append(Object(randint(1,5),randint(1,15),newx,newy))
   





screen.fill((128,128,128))
pygame.display.update()
time = 1

objects=[]
newgame()






while 1:
   if winner != 0:
      gameover(winner)
   pygame.time.wait(20)
   for timeloop in range(1,5):
      turn_update()
      time = time + 1
      if time%500==0:
         for b in bugs:
            if b.team >1:
               b.style=randint(1,3)
      pygame.time.wait(1)
      for event in pygame.event.get():
         pygame.time.wait(1)
         if event.type == QUIT:
            sys.exit()
         if event.type == KEYDOWN:
            keypress =  pygame.key.name(event.key)
         if buttonpressed !=0:
            if butdelay<5:
               butdelay=butdelay+1   
            else:
               buttonpressed=0
               butdelay=5
         if event.type == MOUSEBUTTONDOWN:
            clickx,clicky = pygame.mouse.get_pos()
            buttonpressed = mousemap[clickx][clicky]
            if clickx > 0 and clickx < 660:
               if clicky > 0 and clicky < 660:
                  for b in bugs:
                     if b.team ==1:
                        b.commandx=clickx
                        b.commandy=clicky
            for b in bugs:
               if buttonpressed==6:
                  b.command=randint(1,6)
               if buttonpressed==8:
                  b.command =4
                  b.command3 = 1
                  if b.commandx < 1:
                     b.commandx = b.bugx
                     b.commandy = b.bugy
               if buttonpressed==9:
                  b.command =4
                  b.command3 = 2
                  if b.commandx < 1:
                     b.commandx = b.bugx
                     b.commandy = b.bugy
               if buttonpressed==10:
                  b.command =4
                  b.command3 = 3
                  if b.commandx < 1:
                     b.commandx = b.bugx
                     b.commandy = b.bugy

               if buttonpressed==11:
                  b.command =1
                  if b.commandx < 1:
                     b.commandx = b.bugx
                     b.commandy = b.bugy
               if buttonpressed ==12:
                  b.command = 2
                  if b.commandx < 1:
                     b.commandx = b.bugx
                     b.commandy = b.bugy
               if buttonpressed == 13:
                  b.command = 3
               if buttonpressed == 14:
                  b.command = 6
                  if b.commandx < 1:
                     b.commandx = b.bugx
                     b.commandy = b.bugy
               if buttonpressed == 5:
                  b.command = 5
               if buttonpressed == 6:
                  b.commandx=b.bugx
                  b.commandy=b.bugy
            
   pygame.time.wait(1)
   redrawboard()
